function obj = IsaacIMG_changebits(obj,nbb)
% @IsaacIMG : change le nb de bits d'une image. 
%              ROI ajuste idem, espace colorimtrique ventuellement supprim
%
%	- nbb : nombre de bits de l'image (1  16/32/64)
%				=> modifie ventuellement la classe de l'image (1/8/16/32/64)
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if ismember(nbb,[1,32,64]) 
	bitclass = nbb;
elseif (nbb <= 8)
	bitclass = 8;
elseif (nbb <= 16)
	bitclass = 16;
else
	error('argument incorrect')
end	
obj.img = IsaacIMG_im2nbb(obj,nbb);
obj.nbb = nbb;
obj.bitclass = bitclass;
obj.valmax = IsaacValMax(obj.nbb);
if (obj.dimz == 1)
	obj.min = double(min(min(obj.img)));
	obj.max = double(max(max(obj.img)));
else
	obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
	obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
end
% Ajustement de roi
obj.roi = IsaacROI_adjust(obj.roi,'NBBits',obj.nbb);
if (obj.isroi && ~ISAACPREF.OptimiseImgMem) 
	% si ~obj.isroi le masque valeur reste  false de dimension inchange
	% le masque de roi spatiale reste inchang
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end
if (obj.iscolorspace && ~IsaacECOL_check(obj.colorspace,obj.dimz,obj.bitclass))
	% Effacement espace colorimtrique
	IsaacMessageWarning('espace colorimtrique incompatible supprim')
	obj.colorspace = IsaacECOL(); % espace indtermin par dfaut
	obj.iscolorspace = false;
end
