function obj = IsaacIMG_flip(obj,val)
% @IsaacIMG : mirroir horizontal ou vertical
%        ROI retourne idem, espace colorimtrique inchang
%
%	- val : orientation du miroir = 'h'/'v' 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

switch val
	case 'h'
		for i = 1:obj.dimz
			obj.img(:,:,i) = fliplr(obj.img(:,:,i));
		end
	case 'v'
		for i = 1:obj.dimz
			obj.img(:,:,i) = flipud(obj.img(:,:,i));
		end
	otherwise
		error('argument incorrect')
end
% Ajustement de roi
obj.roi = IsaacROI_flip(obj.roi,val);
if obj.isroi
	if ~ISAACPREF.OptimiseImgMem
		% si ~obj.isroi les masques restent  false de dimension inchange
		obj.roispamask = IsaacROI_spamask(obj.roi);
		obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
	end	
end