function obj = IsaacIMG_reorder(obj,plans)
% @IsaacIMG : rordonne les plans dans l'ordre de la matrice plans.
%        ROI rordonne idem, espace colorimtrique supprim
%
%	- plans  : matrice(1,dimz) des numros de plans => impose l'ordre des plans
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (~isequal(size(plans),[1 obj.dimz]) || any(plans < 1) || any(plans > obj.dimz) || ...
	(length(unique(plans)) ~= length(plans))) % erreur si doublons
	error('argument incorrect')
end
% image
img = obj.img;
imin = obj.min;
imax = obj.max;
for i = 1:obj.dimz
	obj.img(:,:,i) = img(:,:,plans(i));
	obj.min(i) = imin(plans(i));
	obj.max(i) = imax(plans(i));
end
% ajustement roi
obj.roi = IsaacROI_reorder(obj.roi,plans);
% masques de roi inchangs
if (obj.iscolorspace)
	% Effacement espace colorimtrique
	IsaacMessageWarning('espace colorimtrique incompatible supprim')
	obj.colorspace = IsaacECOL(); % espace indtermin par dfaut
	obj.iscolorspace = false;
end

