function val = IsaacImage_get(obj,propname)
% @IsaacImage : lecture d'une proprit
%
% propname				val
% --------				---
% 'ColorSpaceName'	IsaacIMG_get(obj.img,'ColorSpaceName')
% 'Echelle'				obj.echelle
% 'ECOL'             IsaacIMG_get(obj.img,'ColorSpace')
% 'FigHnd'				obj.fighnd
% 'FileName'			obj.filename
% 'IMG'					obj.img
% 'ImgA'             contenu affich = CData 3 plans C8 avec marquage ROI
% 'ImgR'             contenu rel de l'image = IsaacIMG_get(obj.img,'Img')
% 'IsColorSpace'		IsaacIMG_get(obj.img,'IsColorSpace')
% 'IsRoi'				IsaacIMG_get(obj.img,'IsRoi')
% 'IsRoiSpa'			IsaacIMG_get(obj.img,'IsRoiSpa')
% 'IsRoiVal'			IsaacIMG_get(obj.img,'IsRoiVal')
% 'MinMax'				structure = valeurs min et max de obj.img
% 'Name'             IsaacIMG_get(obj.img,'ImgName')
% 'ParamA'				structure = paramtres d'affichage
% 'ParamARoi'			structure = paramtres d'affichage de ROI
% 'ParamR'				structure = donnes relles
% 'ROI'					IsaacIMG_get(obj.img,'Roi')
% 'RSEff'				IsaacIMG_get(obj.img,'RoiSpaEff')
% 'RSMask'				IsaacIMG_get(obj.img,'RoiSpaMask')
% 'RSVEff'				IsaacIMG_get(obj.img,'RoiEff')
% 'RSVMask'				IsaacIMG_get(obj.img,'RoiMask')
% 'RVEff'				IsaacIMG_get(obj.img,'RoiValEff')
% 'RVMask'				IsaacIMG_get(obj.img,'RoiValMask')
% 'Status'				obj.Status
% 'Title'				titre de la fentre image
% 'ValMax'				IsaacIMG_get(obj.img,'ValMax')
% 'Zoom'             zoom actif ou non = obj.zoom
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

switch propname
	case 'ColorSpaceName'
		val = IsaacIMG_get(obj.img,'ColorSpaceName');
	case 'Echelle'
		val = obj.echelle;
	case 'ECOL'
		val = IsaacIMG_get(obj.img,'ColorSpace');
	case 'FigHnd'
		val = obj.fighnd;
	case 'FileName'
		val = obj.filename;
	case 'IMG'
		val = obj.img;
	case 'ImgA'
		val = get(get(obj.axImg,'Children'),'CData');
	case 'ImgR'
		val = IsaacIMG_get(obj.img,'Img');
	case 'IsColorSpace'
		val = IsaacIMG_get(obj.img,'IsColorSpace');
	case 'IsRoi'
		val = IsaacIMG_get(obj.img,'IsRoi');	
	case 'IsRoiSpa'
		val = IsaacIMG_get(obj.img,'IsRoiSpa');	
	case 'IsRoiVal'
		val = IsaacIMG_get(obj.img,'IsRoiVal');	
	case 'MinMax'	
		val.min	= IsaacIMG_get(obj.img,'Min');
		val.max	= IsaacIMG_get(obj.img,'Max');
	case 'Name'
		val = IsaacIMG_get(obj.img,'ImgName');
	case 'ParamA'
		val.plan		= obj.plan;
		val.marginal	= obj.marginal;
		val.ED			= obj.ED;
		val.pal			= obj.pal;
		val.gamma		= obj.gammaA;
	case 'ParamARoi'
		val.showRoiSpa	= obj.showRoiSpa;
		val.showRoiVal	= obj.showRoiVal;
		val.showRoiComp	= obj.showRoiComp;
	case 'ParamR'
		val.dimx		= IsaacIMG_get(obj.img,'DimX');
		val.dimy		= IsaacIMG_get(obj.img,'DimY');
		val.dimz		= IsaacIMG_get(obj.img,'DimZ');
		val.bitclass	= IsaacIMG_get(obj.img,'BitClass');
		val.nbbits		= IsaacIMG_get(obj.img,'NbBits');
	case 'ROI'
		val = IsaacIMG_get(obj.img,'Roi');
	case 'RSEff'
		val = IsaacIMG_get(obj.img,'RoiSpaEff');
	case 'RSMask'
		val = IsaacIMG_get(obj.img,'RoiSpaMask');
	case 'RSVEff'
		val = IsaacIMG_get(obj.img,'RoiEff');
	case 'RSVMask'
		val = IsaacIMG_get(obj.img,'RoiMask');
	case 'RVEff'
		val = IsaacIMG_get(obj.img,'RoiValEff');
	case 'RVMask'
		val = IsaacIMG_get(obj.img,'RoiValMask');
	case 'Status'
		val = obj.status;
	case 'Title'
		val = get(obj.fighnd,'Name');
	case 'ValMax'
		val = IsaacIMG_get(obj.img,'ValMax');
	case 'Zoom'
		val = obj.zoom;
	otherwise
		error('proprit inconnue')
end
