function IsaacImage_event(obj,auteur,event)
% @IsaacImage (private) : envoie	l'venement  tous les outils dclars dans ISAACPRIV.TabUpd
%
% - auteur : handle figure (outil ou image) qui a provoqu l'vnement	 
% - event  : code de l'vnement
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
% Contributor: Clment Bourgeais (2018)
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

%	---------------------  
%	Liste des codes event
%	---------------------
%
%	1   : plus d'image cible
%
%	2   : changement de cible
%
%	11  : Avertissement AVANT fermeture image cible
%			(=> vnement 1 ou 2)
%	12  : Avertissement AVANT fermeture image non cible
%
%	20  : nouvelle image
%			(peut => vnement 2 si 1re image ouverte)
%
%	31  : rinitialisation ou modif dimXY|nbbits|nbplans|(ROI & ECOL)) image cible
%			=> modifs [Echelle], [ECOL], ImgA, [ImgR], [ParamA], [ParamARoi], ParamR, ROI,
%						[RSMask], RVMask, [Status], [Title], [Zoom]
%	32  : idem non cible
%
%	41  : modif ROI et contenu rel image cible 
%			=> modifs ImgA, ImgR, [ParamARoi], ROI, [RSMask], RVMask, [Status]
%	42  : idem non cible
%
%	51  : modif ECOL et contenu rel image cible
%			=> modifs ECOL, ImgA, ImgR, RVMask, [Status], Title
%	52  : idem non cible
%
%	61  : modif contenu rel image cible
%			=> modifs ImgA, ImgR, RVMask, [Status]
%	62  : idem non cible
%
%	71  : modif ROI image cible 
%			=> modifs [ImgA], [ParamARoi], ROI, [RSMask], [RVMask], [Status]
%	72  : idem non cible
%
%	81  : modif ECOL image cible
%			=> modifs ECOL, [Status], Title
%	82  : idem non cible
%
%	91  : modif params d'affichage
%			=> modifs ImgA, [ParamA], [ParamARoi]
%	92  : idem non cible
%
%	101 : modif chelle ou zoom image cible
%			=> modifs [Echelle], [Zoom]
%	102 : idem non cible
%
%	111 : changement de nom image cible
%			=> modif [Status], Title
%	112 : idem non cible
%
%
%	PRINCIPE GENERAL : sauf 11 et 12, les vnements sont envoys APRES l'action

%---------------------------------------------------------------------------------------------------

global ISAACPRIV

if ISAACPRIV.DispEvent
   if verLessThan('matlab', '8.4')
      % code pour MATLAB 2014a et antrieur
      disp(['> Isaac event ',num2str(event),'/image ',num2str(obj.fighnd),'/auteur ', ...
         num2str(auteur)])
   else
      % code pour MATLAB 2014b (8.4) et postrieur
      disp(['> Isaac event ',num2str(event),'/image ',num2str(obj.fighnd.Number),'/auteur ', ...
         num2str(auteur.Number)])
   end
end
for i=1:ISAACPRIV.NbUpd
	try
		% le nom de la fonction ne doit pas contenir de chemin et doit tre dans le path
		feval(ISAACPRIV.TabUpd(i).filename,ISAACPRIV.TabUpd(i).hnd,event,obj,auteur)
	catch exception
		% pour ne pas interrompre la boucle
		IsaacMessageErreur(IsaacError(exception))
	end	
end
end