function s = IsaacImage_title(obj)
% @IsaacImage (private) : retourne le nom de l'image pour affichage
% en fonction de ISAACPREF.ShowImType et ISAACPREF.ImFullName.
%
% pas d'affichage du nom de fichier complet si status = -1
% pas d'affichage du nom d'espace couleur si colorspace non dfini
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if (ISAACPREF.ImFullName && (obj.status ~= -1))
	s1 = IsaacPathStr(obj.filename,2);
else
	s1 = IsaacIMG_get(obj.img,'ImgName');
end
if ISAACPREF.ShowImType
	s2 = [s1,' (',num2str(IsaacIMG_get(obj.img,'DimZ')),'x', ...
		num2str(IsaacIMG_get(obj.img,'NbBits')),')'];
	if IsaacIMG_get(obj.img,'IsColorSpace')
		s = [s2,' ',IsaacIMG_get(obj.img,'ColorSpaceName')];
	else	
		s = s2;
	end	
else
	s = s1;
end		
end
