function mess = IsaacError(err)
% Retourne un message d'erreur issu de err et format selon ISAACPREF.Mode
% err = objet de la classe MException
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
% Contributor: Clment Bourgeais (2018)
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if (ISAACPREF.Mode == 3)
    % En mode dbug, err.stack(k) permet de rcuprer la kime erreur de la chane d'excution
    % Un lien cliquable permet d'ouvrir le fichier  la ligne concerne

    errchaine = 'Debug stack = ';
    depth=length(err.stack);
    if (depth > 1)    
        for k = depth:-1:2       
            errchaine = [errchaine,'<a href="matlab:opentoline(''',err.stack(k).file,''',',...
                num2str(err.stack(k).line),',0)">',err.stack(k).name,' at',' ', ...
                num2str(err.stack(k).line),'</a>',' > '];                                       %#ok
        end
    end
    errchaine = [errchaine,'<a href="matlab:opentoline(''',err.stack(1).file,''',',...
                num2str(err.stack(1).line),',0)">',err.stack(1).name,' at',' ', ...
                num2str(err.stack(1).line),'</a>']; 
    
    if verLessThan('matlab', '9.1') 
      % code pour MATLAB 2016a et antrieur
      mess = [err.message,char(10),errchaine];                                                  %#ok
    else
      % code pour MATLAB 2016b (9.1) et postrieur  
        mess = [err.message,newline,errchaine];
    end
else
    mess = err.message;
end

% strcat() supprime les espaces => utiliser [ ... , ... ]  la place 
% disp n'interprte pas la syntaxe '\n' => utiliser char(10)  la place ou newline  partir de 2016b 

   
