function filename2 = IsaacImgFileName(varargin)
% Retourne un nom de fichier du type [str1]filename[str2].ext
% avec longueur ventuellement rduite en privilgiant str1  str2  filename
% et extension correspondant au format d'image choisi en prfrences
%
%	filename2 = IsaacImgFileName(filename) 
%	filename2 = IsaacImgFileName(filename,str2)
%	filename2 = IsaacImgFileName(str1,filename,str2) 
%
%	- filename  : nom du fichier dans rpertoire courant ou nom complet 
%	- filename2 : nom du fichier dans rpertoire courant ou nom complet 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

switch nargin
	case 1
		[parentdir,shortfilename] = fileparts(varargin{1});
		filename2 = IsaacFileName([shortfilename,ISAACPREF.ImForm]);
	case 2
		[parentdir,shortfilename] = fileparts(varargin{1});
		filename2 = IsaacFileName([shortfilename,ISAACPREF.ImForm],varargin{2});	
	case 3
		[parentdir,shortfilename] = fileparts(varargin{2});
		filename2 = IsaacFileName(varargin{1},[shortfilename,ISAACPREF.ImForm],varargin{3});	
	otherwise
		error('nombre d''arguments incorrect')
end
filename2 = fullfile(parentdir,filename2); % gre parentdir = '' ou '/'