function varargout = FixeNbBits(varargin)
% Fixe le nombre de bits rellement utiliss par l'image
% Sans requantification ni modification de la classe de bits (1/8/16/32/64)
%
% INPUT:
% - image PxQ1
% - valeur numrique : nombre de bits utiliss (1  16,32,64)
%
% OUTPUT:
% - image PxQ2
%
% Plugin for OpenIsaac
% version 1
%  2011-2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% PLUGIN PARAMETERS
if (nargin == 1) && strcmp(varargin{1},'-f')
    % input
	varargout{1} = {'IMG','image', ...
					'DATA','nombre de bits utiliss'};
    % output
	varargout{2} = {'IMG','image'};
	return
end	

% INPUT
ObjIMG = varargin{1};
nbb = IsaacDATA_get(varargin{2},'Val');

%---------------------------------------------------------------------------------------------------

ObjIMG = IsaacIMG_set(ObjIMG,'NbBitsUsed',nbb);

%---------------------------------------------------------------------------------------------------

% OUTPUT
varargout{1} = ObjIMG;