function RoiEdit_cb(choix)
% Callback RoiEdit
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)

% ROI Spatiale -------------------------------------------------------------------------------------

case 'ChkRoiSpatiale'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacROI_set(ud.Param,'IsRoiSpa',logical(get(gcbo,'Value')));
	set(gcbf,'UserData',ud)
	MajSpaWhenChange
case 'RadButRSOU'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Param = IsaacROI_set(ud.Param,'RoiSpaIn',true);
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButRSNI'),'Value',0)
		MajSpaWhenChange	
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButRSNI'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Param = IsaacROI_set(ud.Param,'RoiSpaIn',false);
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButRSOU'),'Value',0)
		MajSpaWhenChange
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ListRS'
	ud = get(gcbf,'UserData');
	ud.RoiSpaL = get(gcbo,'Value');
	roispa = IsaacROI_get(ud.Param,'RoiSpa');
	ud.RoiSpaE1 = roispa(ud.RoiSpaL,1);
	ud.RoiSpaE2 = roispa(ud.RoiSpaL,2);
	ud.RoiSpaE3 = roispa(ud.RoiSpaL,3);
	ud.RoiSpaE4 = roispa(ud.RoiSpaL,4);
	set(gcbf,'UserData',ud)
	set(findobj(gcbf,'Tag','EtxtRS1'),'String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS2'),'String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS3'),'String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS4'),'String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
case 'EtxtRS1'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 1) || (v > ud.RoiSpaE2))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiSpaFormat))
		ud.RoiSpaE1 = v;
		roispa = IsaacROI_get(ud.Param,'RoiSpa');
		roispa(ud.RoiSpaL,1) = ud.RoiSpaE1;
		ud.Param = IsaacROI_set(ud.Param,'RoiSpa',roispa);
		set(gcbf,'UserData',ud);
		MajListeRoiSpa
		MajSpaWhenChange
	end	
case 'EtxtRS2'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < ud.RoiSpaE1) || (v > imaref.dimx))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiSpaFormat))
		ud.RoiSpaE2 = v;
		roispa = IsaacROI_get(ud.Param,'RoiSpa');
		roispa(ud.RoiSpaL,2) = ud.RoiSpaE2;
		ud.Param = IsaacROI_set(ud.Param,'RoiSpa',roispa);
		set(gcbf,'UserData',ud);
		MajListeRoiSpa
		MajSpaWhenChange
	end	
case 'EtxtRS3'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 1) || (v > ud.RoiSpaE4))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiSpaFormat))
		ud.RoiSpaE3 = v;
		roispa = IsaacROI_get(ud.Param,'RoiSpa');
		roispa(ud.RoiSpaL,3) = ud.RoiSpaE3;
		ud.Param = IsaacROI_set(ud.Param,'RoiSpa',roispa);
		set(gcbf,'UserData',ud);
		MajListeRoiSpa
		MajSpaWhenChange
	end	
case 'EtxtRS4'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < ud.RoiSpaE3) || (v > imaref.dimy))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiSpaFormat))
		ud.RoiSpaE4 = v;
		roispa = IsaacROI_get(ud.Param,'RoiSpa');
		roispa(ud.RoiSpaL,4) = ud.RoiSpaE4;
		ud.Param = IsaacROI_set(ud.Param,'RoiSpa',roispa);
		set(gcbf,'UserData',ud);
		MajListeRoiSpa
		MajSpaWhenChange
	end	
case 'ButRSselect'
	rect = IsaacImage_mouserect(IsaacImageCible);
	if isempty(rect)
		IsaacMessageWarning('slection vide')
		return
	end
	ud = get(gcbf,'UserData');
	ud.RoiSpaE1 = rect(1);
	ud.RoiSpaE2 = ud.RoiSpaE1 + rect(3) - 1;
	ud.RoiSpaE3 = rect(2);
	ud.RoiSpaE4 = ud.RoiSpaE3 + rect(4) - 1;
	try
		ud.Param = IsaacROI_add(ud.Param,'RoiSpa',[ud.RoiSpaE1,ud.RoiSpaE2,ud.RoiSpaE3,ud.RoiSpaE4]);
	catch
		IsaacMessageErreur('slection incompatible')
		return
	end
	ud.RoiSpaL = IsaacROI_get(ud.Param,'RoiSpaNb');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRS'),'Enable','on')
	MajListeRoiSpa	
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','on','String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','on','String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','on','String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','on','String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRSclear'),'Enable','on')
	MajSpaWhenChange
case 'ButRSlp'
	objLPIX = IsaacParamPull('LPIX');
	if isempty(objLPIX)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String','pas de LPIX en mmoire')
		return
	end
	nb = IsaacLPIX_get(objLPIX,'PixNb');
	if (nb == 0)
		IsaacMessageWarning('la liste de pixels mmorise est vide')
		return
	end
	ud = get(gcbf,'UserData');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if ~IsaacLPIX_check(objLPIX,'PixSpa',imaref.dimx,imaref.dimy)
		IsaacMessageWarning('liste de pixels incompatible')
		return
	end
	% ajout de la liste
	L = IsaacLPIX_get(objLPIX,'PixSpa');
	for i = 1:nb
		ud.Param = IsaacROI_add(ud.Param,'RoiSpa',[L(i,1),L(i,1),L(i,2),L(i,2)]);
	end
	roispa = IsaacROI_get(ud.Param,'RoiSpa');
	ud.RoiSpaL = IsaacROI_get(ud.Param,'RoiSpaNb');
	ud.RoiSpaE1 = roispa(ud.RoiSpaL,1);
	ud.RoiSpaE2 = roispa(ud.RoiSpaL,2);
	ud.RoiSpaE3 = roispa(ud.RoiSpaL,3);
	ud.RoiSpaE4 = roispa(ud.RoiSpaL,4);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRS'),'Enable','on')
	MajListeRoiSpa
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','on','String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','on','String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','on','String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','on','String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRSclear'),'Enable','on')
	MajSpaWhenChange
case 'ButRSclear'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacROI_clear(ud.Param,'RoiSpa');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRS'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','off','String','')	
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','off')
	set(gcbo,'Enable','off')
	MajSpaWhenChange	
case 'ButRS+'
	ud = get(gcbf,'UserData');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	val = [1,imaref.dimx,1,imaref.dimy];
	ud.Param = IsaacROI_add(ud.Param,'RoiSpa',val);
	ud.RoiSpaL = IsaacROI_get(ud.Param,'RoiSpaNb');
	ud.RoiSpaE1 = val(1);
	ud.RoiSpaE2 = val(2);
	ud.RoiSpaE3 = val(3);
	ud.RoiSpaE4 = val(4);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRS'),'Enable','on')
	MajListeRoiSpa
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','on','String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','on','String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','on','String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','on','String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRSclear'),'Enable','on')
	MajSpaWhenChange
case 'ButRS-'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacROI_remove(ud.Param,'RoiSpa',ud.RoiSpaL);
	roispanb = IsaacROI_get(ud.Param,'RoiSpaNb');
	if (roispanb == 0)
		set(gcbo,'Enable','off')
		set(findobj(gcbf,'Tag','ListRS'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','off','String','')	
		set(findobj(gcbf,'Tag','ButRSclear'),'Enable','off')
	else
		if ud.RoiSpaL > roispanb
			ud.RoiSpaL = roispanb;
		end
		roispa = IsaacROI_get(ud.Param,'RoiSpa');
		ud.RoiSpaE1 = roispa(ud.RoiSpaL,1);
		ud.RoiSpaE2 = roispa(ud.RoiSpaL,2);
		ud.RoiSpaE3 = roispa(ud.RoiSpaL,3);
		ud.RoiSpaE4 = roispa(ud.RoiSpaL,4);
		MajListeRoiSpa
		set(findobj(gcbf,'Tag','EtxtRS1'),'String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
		set(findobj(gcbf,'Tag','EtxtRS2'),'String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
		set(findobj(gcbf,'Tag','EtxtRS3'),'String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
		set(findobj(gcbf,'Tag','EtxtRS4'),'String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	end	
	set(gcbf,'UserData',ud);
	MajSpaWhenChange
	
% ROI Valeurs --------------------------------------------------------------------------------------

case 'RadButRVOU'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Param = IsaacROI_set(ud.Param,'RoiValIn',true);
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButRVNI'),'Value',0)
		MajValWhenChange
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButRVNI'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.Param = IsaacROI_set(ud.Param,'RoiValIn',false);
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButRVOU'),'Value',0)
		MajValWhenChange
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ListRV'
	ud = get(gcbf,'UserData');
	roival = IsaacROI_get(ud.Param,'RoiVal');
	ud.RoiValL = get(gcbo,'Value');
	ud.RoiValE1 = roival(ud.RoiValL,2*ud.RoiValP-1);
	ud.RoiValE2 = roival(ud.RoiValL,2*ud.RoiValP);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','EtxtRV1'),'String',num2str(ud.RoiValE1,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','EtxtRV2'),'String',num2str(ud.RoiValE2,ud.RoiValFormat))
case 'PopupPlanRV'
	ud = get(gcbf,'UserData');
	ud.RoiValP = get(gcbo,'Value');
	isroival = IsaacROI_get(ud.Param,'IsRoiVal');
	set(findobj(gcbf,'Tag','ChkRoiValeurs'),'Value',isroival(ud.RoiValP))
	roival = IsaacROI_get(ud.Param,'RoiVal');
	roivalnb = IsaacROI_get(ud.Param,'RoiValNb');
	if (roivalnb > 0)
		ud.RoiValE1 = roival(ud.RoiValL,2*ud.RoiValP-1);
		ud.RoiValE2 = roival(ud.RoiValL,2*ud.RoiValP);
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','EtxtRV1'),'String',num2str(ud.RoiValE1,ud.RoiValFormat))
		set(findobj(gcbf,'Tag','EtxtRV2'),'String',num2str(ud.RoiValE2,ud.RoiValFormat))
	end	
case 'ChkRoiValeurs'
	ud = get(gcbf,'UserData');
	isroival = IsaacROI_get(ud.Param,'IsRoiVal');
	isroival(get(findobj(gcbf,'Tag','PopupPlanRV'),'Value')) = logical(get(gcbo,'Value'));
	ud.Param = IsaacROI_set(ud.Param,'IsRoiVal',isroival);
	set(gcbf,'UserData',ud);
	MajValWhenChange
case 'EtxtRV1'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if imaref.nbb > 16
		v = str2double(vstr);
	else
		v = round(str2double(vstr));
	end
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 0) || (v > ud.RoiValE2))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiValE1,ud.RoiValFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiValFormat))
		ud.RoiValE1 = v;
		roival = IsaacROI_get(ud.Param,'RoiVal');
		roival(ud.RoiValL,2*ud.RoiValP-1) = ud.RoiValE1;
		ud.Param = IsaacROI_set(ud.Param,'RoiVal',roival);
		set(gcbf,'UserData',ud);
		MajListeRoiVal
		MajValWhenChange
	end	
case 'EtxtRV2'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if imaref.nbb > 16
		v = str2double(vstr);
	else
		v = round(str2double(vstr));
	end
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < ud.RoiValE1) || ...
         (v > IsaacROI_get(ud.Param,'RoiValMax')))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.RoiValE2,ud.RoiValFormat))
	else
		set(gcbo,'String',num2str(v,ud.RoiValFormat))
		ud.RoiValE2 = v;
		roival = IsaacROI_get(ud.Param,'RoiVal');
		roival(ud.RoiValL,2*ud.RoiValP) = ud.RoiValE2;
		ud.Param = IsaacROI_set(ud.Param,'RoiVal',roival);
		set(gcbf,'UserData',ud);
		MajListeRoiVal
		MajValWhenChange
	end	
case 'ButRVlp'
	objLPIX = IsaacParamPull('LPIX');
	if isempty(objLPIX)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String','pas de LPIX en mmoire')
		return
	end
	nb = IsaacLPIX_get(objLPIX,'PixNb');
	if (nb == 0)
		IsaacMessageWarning('la liste de pixels mmorise est vide')
		return
	end
	ud = get(gcbf,'UserData');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	if ~IsaacLPIX_check(objLPIX,'PixVal',imaref.dimz)
		IsaacMessageWarning('liste de pixels incompatible')
		return
	end
	% conversion des valeurs double de la liste
	if (imaref.nbb == 1)
      if verLessThan('matlab', '9.0') 
         % code pour MATLAB 2015b et antrieur
         L = double(im2bw(IsaacLPIX_get(objLPIX,'PixVal'),0.5));                                %#ok
      else
         % code pour MATLAB 2016a (9.0) et postrieur
         L = double(imbinarize(IsaacLPIX_get(objLPIX,'PixVal'),0.5));
      end
	elseif (imaref.nbb <= 16)
		L = round(IsaacLPIX_get(objLPIX,'PixVal')*IsaacROI_get(ud.Param,'RoiValMax'));
	else	
		L = IsaacLPIX_get(objLPIX,'PixVal');
	end
	% ajout de la liste
	val = zeros(1,2*imaref.dimz);
	for i = 1:nb
		for j = 1:imaref.dimz
			val(2*j-1) = L(i,j);
			val(2*j) = L(i,j);																			
		end
		ud.Param = IsaacROI_add(ud.Param,'RoiVal',val);
	end
	roival = IsaacROI_get(ud.Param,'RoiVal');
	ud.RoiValL = IsaacROI_get(ud.Param,'RoiValNb');
	ud.RoiValE1 = roival(ud.RoiValL,2*ud.RoiValP-1);
	ud.RoiValE2 = roival(ud.RoiValL,2*ud.RoiValP);
	set(gcbf,'UserData',ud)
	set(findobj(gcbf,'Tag','ListRV'),'Enable','on')
	MajListeRoiVal
	set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','on','String',num2str(ud.RoiValE1,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','on','String',num2str(ud.RoiValE2,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','ButRV-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRVclear'),'Enable','on')
	MajValWhenChange
case 'ButRVclear'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacROI_clear(ud.Param,'RoiVal');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRV'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','ButRV-'),'Enable','off')
	set(gcbo,'Enable','off')
	MajValWhenChange
case 'ButRV+'
	ud = get(gcbf,'UserData');
	max = IsaacROI_get(ud.Param,'RoiValMax');
	imaref = IsaacROI_get(ud.Param,'ImaRef');
	val = repmat([0,max],1,imaref.dimz);
	ud.Param = IsaacROI_add(ud.Param,'RoiVal',val);
	ud.RoiValL = IsaacROI_get(ud.Param,'RoiValNb');
	ud.RoiValE1 = val(2*ud.RoiValP-1);
	ud.RoiValE2 = val(2*ud.RoiValP);
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','ListRV'),'Enable','on')
	MajListeRoiVal
	set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','on','String',num2str(ud.RoiValE1,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','on','String',num2str(ud.RoiValE2,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','ButRV-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRVclear'),'Enable','on')
	MajValWhenChange
case 'ButRV-'
	ud = get(gcbf,'UserData');
	ud.Param = IsaacROI_remove(ud.Param,'RoiVal',ud.RoiValL);
	roivalnb = IsaacROI_get(ud.Param,'RoiValNb');
	if (roivalnb == 0)
		set(gcbo,'Enable','off')
		set(findobj(gcbf,'Tag','ListRV'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','ButRVclear'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','off','String','')
		set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','off','String','')
	else
		if ud.RoiValL > roivalnb
			ud.RoiValL = roivalnb;
		end
		roival = IsaacROI_get(ud.Param,'RoiVal');
		ud.RoiValE1 = roival(ud.RoiValL,2*ud.RoiValP-1);
		ud.RoiValE2 = roival(ud.RoiValL,2*ud.RoiValP);
		MajListeRoiVal
		set(findobj(gcbf,'Tag','EtxtRV1'),'String',num2str(ud.RoiValE1,ud.RoiValFormat))
		set(findobj(gcbf,'Tag','EtxtRV2'),'String',num2str(ud.RoiValE2,ud.RoiValFormat))
	end	
	set(gcbf,'UserData',ud);
	MajValWhenChange
case 'ButDoMasqueS'
	cible = IsaacImageCible;
	mask = IsaacImage_get(cible,'RSMask');
	try
		IsaacImage(gcbf,mask,[IsaacImage_get(cible,'Name'),'-ROISpa'],[],[]);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
case 'ButDoMasqueV'
	cible = IsaacImageCible;
	mask = IsaacImage_get(cible,'RVMask');
	try
		IsaacImage(gcbf,mask,[IsaacImage_get(cible,'Name'),'-ROIVal'],[],[]);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
case 'ButDoMasqueSV'
	cible = IsaacImageCible;
	mask = IsaacImage_get(cible,'RSVMask');
	try
		IsaacImage(gcbf,mask,[IsaacImage_get(cible,'Name'),'-ROISpaVal'],[],[]);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
	
% Gnral ------------------------------------------------------------------------------------------

case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Appliquer')
		cible = IsaacImageCible;
		if isempty(cible)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
				'String','pas d''image cible')
			set(findobj(gcbf,'Tag','ButParamPull'),'Enable','off','String','Crer')
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off')
			set(findobj(gcbf,'Tag','ButSupprimer'),'Enable','off','Visible','on')
		else
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String',IsaacImage_get(cible,'Name'))
			if IsaacImage_get(cible,'IsRoi');
				set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer')
				set(findobj(gcbf,'Tag','ButSupprimer'),'Enable','on','Visible','on')
			else
				set(findobj(gcbf,'Tag','ButParamPull'),'String','Crer')
				set(findobj(gcbf,'Tag','ButSupprimer'),'Enable','off','Visible','on')
			end
			if ~isempty(ud.Param)
				set(findobj(gcbf,'Tag','ButRSselect'),'Enable','on')
			end	
		end
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 2;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Lire')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Ecrire')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Ecrire')
		end
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
		set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
		set(findobj(gcbf,'Tag','ButRSselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 3;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Ouvrir...')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Sauver sous...')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Sauver sous...')
		end
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
		set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
		set(findobj(gcbf,'Tag','ButRSselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Importer')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Exporter')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Exporter')
		end
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
		set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
		set(findobj(gcbf,'Tag','ButRSselect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')	
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			ud.Param = IsaacImage_get(cible,'ROI');
			MajWhenPull
			set(gcbf,'UserData',ud);
			MajEffRoiSpa
			MajEffRoiVal
			set(findobj(gcbf,'Tag','ButRSselect'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','on')
		case 2 % Mmoire
			P = IsaacParamPull('ROI');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				ud.Param = P;
				MajWhenPull
				set(gcbf,'UserData',ud);
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir une rgion d''intrt :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacROI(fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				ud.Param = IsaacParamImport('ROI',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			try
 				IsaacImage_set(cible,gcbf,'ROI',ud.Param);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				return
			end
			MajEffRoiSpa
			MajEffRoiVal
			set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer')
			set(findobj(gcbf,'Tag','ButSupprimer'),'Enable','on','Visible','on')
			set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','on')
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','ROI mmorise')
		case 3 % Fichier
			[filename,dirname] = IsaacUIputfile('Sauver sous :',IsaacFileName('ROI.mat'));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacROI_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' sauv'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' exporte'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end	
	end
case 'ButSupprimer'
	ud = get(gcbf,'UserData');
	cible = IsaacImageCible;
	try
		IsaacImage_set(cible,gcbf,'ROI',[]);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
	set(gcbo,'Enable','off')
	set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
	set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
	set(findobj(gcbf,'Tag','ButParamPull'),'String','Crer')
	set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','off')
	set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','off')
	set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajWhenPull
	
% Roi spatiale
isroispa = IsaacROI_get(ud.Param,'IsRoiSpa');
set(findobj(gcbf,'Tag','ChkRoiSpatiale'),'Enable','on','Value',isroispa)
roispain = IsaacROI_get(ud.Param,'RoiSpaIn');
set(findobj(gcbf,'Tag','RadButRSOU'),'Enable','on','Value',roispain)
set(findobj(gcbf,'Tag','RadButRSNI'),'Enable','on','Value',~roispain)
ud.RoiSpaFormat = '%5.4i';
roispanb = IsaacROI_get(ud.Param,'RoiSpaNb');
if ~roispanb
	set(findobj(gcbf,'Tag','ListRS'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','off')
	set(findobj(gcbf,'Tag','ButRSclear'),'Enable','off')
else
	roispa = IsaacROI_get(ud.Param,'RoiSpa');
	ud.RoiSpaL = roispanb;
	ud.RoiSpaE1 = roispa(ud.RoiSpaL,1);
	ud.RoiSpaE2 = roispa(ud.RoiSpaL,2);
	ud.RoiSpaE3 = roispa(ud.RoiSpaL,3);
	ud.RoiSpaE4 = roispa(ud.RoiSpaL,4);
	set(findobj(gcbf,'Tag','ListRS'),'Enable','on')
	MajListeRoiSpa
	set(findobj(gcbf,'Tag','EtxtRS1'),'Enable','on','String',num2str(ud.RoiSpaE1,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS2'),'Enable','on','String',num2str(ud.RoiSpaE2,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS3'),'Enable','on','String',num2str(ud.RoiSpaE3,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','EtxtRS4'),'Enable','on','String',num2str(ud.RoiSpaE4,ud.RoiSpaFormat))
	set(findobj(gcbf,'Tag','ButRS-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRSclear'),'Enable','on')
end
set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
set(findobj(gcbf,'Tag','ButRSlp'),'Enable','on')
set(findobj(gcbf,'Tag','ButRS+'),'Enable','on')
% ROI valeurs
roivalin = IsaacROI_get(ud.Param,'RoiValIn');
set(findobj(gcbf,'Tag','RadButRVOU'),'Enable','on','Value',roivalin)
set(findobj(gcbf,'Tag','RadButRVNI'),'Enable','on','Value',~roivalin)
imaref = IsaacROI_get(ud.Param,'ImaRef');
s = cell(imaref.dimz,1);
for ii = 1:imaref.dimz
	s{ii} = num2str(ii);
end
ud.RoiValP = 1;
if imaref.dimz == 1
	set(findobj(gcbf,'Tag','PopupPlanRV'),'Enable','inactive','String',s,'Value',ud.RoiValP)
else
	set(findobj(gcbf,'Tag','PopupPlanRV'),'Enable','on','String',s,'Value',ud.RoiValP)
end	
isroival = IsaacROI_get(ud.Param,'IsRoiVal');
set(findobj(gcbf,'Tag','ChkRoiValeurs'),'Enable','on','Value',isroival(ud.RoiValP))
if (imaref.nbb == 1)
	ud.RoiValFormat = '%2.1i';
elseif (imaref.nbb <= 8)
	ud.RoiValFormat = '%4.3i';
elseif (imaref.nbb <= 16)
	ud.RoiValFormat = '%6.5i';
else
	ud.RoiValFormat = '%7.4f';
end
roivalnb = IsaacROI_get(ud.Param,'RoiValNb');
if ~roivalnb
	set(findobj(gcbf,'Tag','ListRV'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','off','String','')
	set(findobj(gcbf,'Tag','ButRV-'),'Enable','off')
	set(findobj(gcbf,'Tag','ButRVclear'),'Enable','off')
else
	roival = IsaacROI_get(ud.Param,'RoiVal');
	ud.RoiValL = roivalnb;
	ud.RoiValE1 = roival(ud.RoiValL,2*ud.RoiValP-1);
	ud.RoiValE2 = roival(ud.RoiValL,2*ud.RoiValP);
	set(findobj(gcbf,'Tag','ListRV'),'Enable','on')
	MajListeRoiVal
	set(findobj(gcbf,'Tag','EtxtRV1'),'Enable','on','String',num2str(ud.RoiValE1,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','EtxtRV2'),'Enable','on','String',num2str(ud.RoiValE2,ud.RoiValFormat))
	set(findobj(gcbf,'Tag','ButRV-'),'Enable','on')
	set(findobj(gcbf,'Tag','ButRVclear'),'Enable','on')
end
set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
set(findobj(gcbf,'Tag','ButRVlp'),'Enable','on')
set(findobj(gcbf,'Tag','ButRV+'),'Enable','on')
% Gneral
set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on')	
s = ['ROI (',num2str(imaref.dimx),' x ',num2str(imaref.dimy),' x ',num2str(imaref.dimz), ...
	'  -  ',num2str(imaref.nbb)];
if (imaref.nbb == 1)
	set(findobj(gcbf,'Tag','StxtParamInfo'),'String',[s, ' bit)'])
else
	set(findobj(gcbf,'Tag','StxtParamInfo'),'String',[s, ' bits)'])
end	

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajEffRoiSpa

if IsaacImage_get(cible,'IsRoiSpa')
	set(findobj(gcbf,'Tag','StxtRSeffval'),'String',num2str(IsaacImage_get(cible,'RSEff')))
else
	set(findobj(gcbf,'Tag','StxtRSeffval'),'String','aucun')
end	

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajEffRoiVal

if IsaacImage_get(cible,'IsRoiVal')
	set(findobj(gcbf,'Tag','StxtRVeffval'),'String',num2str(IsaacImage_get(cible,'RVEff')))
else
	set(findobj(gcbf,'Tag','StxtRVeffval'),'String','aucun')
end	

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajListeRoiSpa
	
roisspa = IsaacROI_get(ud.Param,'RoiSpa');
n = size(roisspa,1);
s = cell(n,1);
for ii = 1:n
	s{ii} = ['  ',num2str(roisspa(ii,1:2),ud.RoiSpaFormat), ...
				  '   ',num2str(roisspa(ii,3:4),ud.RoiSpaFormat)];
end
set(findobj(gcbf,'Tag','ListRS'),'String',s,'Value',ud.RoiSpaL)

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajListeRoiVal
	
roival = IsaacROI_get(ud.Param,'RoiVal');
n1 = size(roival,1);
n2 = size(roival,2) / 2;
s = cell(n1,1);
for ii = 1:n1
	s{ii} = '';
	for jj = 1:n2-1
		s{ii} = [s{ii},num2str(roival(ii,2*jj-1:2*jj),ud.RoiValFormat),'   '];
	end
	s{ii} = [s{ii},num2str(roival(ii,2*n2-1:2*n2),ud.RoiValFormat)];
end	
set(findobj(gcbf,'Tag','ListRV'),'String',s,'Value',ud.RoiValL)

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajSpaWhenChange

set(findobj(gcbf,'Tag','StxtRSeffval'),'String','')
set(findobj(gcbf,'Tag','ButDoMasqueS'),'Enable','off')
set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajValWhenChange
	
set(findobj(gcbf,'Tag','StxtRVeffval'),'String','')
set(findobj(gcbf,'Tag','ButDoMasqueV'),'Enable','off')
set(findobj(gcbf,'Tag','ButDoMasqueSV'),'Enable','off')

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin RoiEdit_cb en raison des nested fonctions
