function IsaacMenuBar_cb(choix)
% Callback IsaacMenuBar
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% Utilise la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACCONST
global ISAACPRIV
global ISAACPREF

switch(choix)
case 'CloseBox'
   if ~ISAACPRIV.IsEnd
      if ISAACPREF.CloseMenuEnd
         IsaacEngine('-endconfirm')
      else
         IsaacEventUpdListe(gcbf,[])
         closereq
      end   
   else   
      closereq
   end   
% Clic sur barre de menu Isaac ---------------------------------------------------------------------
case 'MajMenuIsaac'
	ud = get(gcbf,'UserData');
	h1 = findobj(gcbf,'Tag','MenuIsaac');
	if ud.PointeurInfo
		set(findobj(h1,'Tag','MItemPointeurInfo'),'Checked','on')
	else
		set(findobj(h1,'Tag','MItemPointeurInfo'),'Checked','off')
	end    
	if ISAACPRIV.Bavard
		set(findobj(h1,'Tag','MItemModeBavard'),'Checked','on')
	else
		set(findobj(h1,'Tag','MItemModeBavard'),'Checked','off')
	end    
% Menu Isaac ---------------------------------------------------------------------------------------
case 'MItemAbout'
	IsaacAbout
case 'MItemPrefs'
	IsaacPrefs
case 'MItemPointeurInfo'
	ud = get(gcbf,'UserData');
	ud.PointeurInfo = ~ud.PointeurInfo;
	set(gcbf,'UserData',ud)
case 'MItemModeBavard'
	ISAACPRIV.Bavard = ~ISAACPRIV.Bavard;
case 'MItemQuit'
	IsaacEngine('-endconfirm')
% Clic sur barre de menu Fichier -------------------------------------------------------------------
case 'MajMenuFile'
	h1 = findobj(gcbf,'Tag','MenuFile');
	if ISAACPRIV.NbOpenImg
		val = IsaacImage_get(ISAACPRIV.Cible,'Status');
		if (val == 0)
			set(findobj(h1,'Tag','MItemSaveImage'),'Enable','on')
			set(findobj(h1,'Tag','MItemRestaureImage'),'Enable','on')
		else
			set(findobj(h1,'Tag','MItemSaveImage'),'Enable','off')
			set(findobj(h1,'Tag','MItemRestaureImage'),'Enable','off')
		end	
		set(findobj(h1,'Tag','MItemSaveImageAs'),'Enable','on')
	else
		set(findobj(h1,'Tag','MItemSaveImage'),'Enable','off')
		set(findobj(h1,'Tag','MItemSaveImageAs'),'Enable','off')
		set(findobj(h1,'Tag','MItemRestaureImage'),'Enable','off')
	end
% Menu Fichier -------------------------------------------------------------------------------------    
case 'MItemNewImage'
	IsaacNewImage
case 'MItemImportImage'
	dirname = IsaacUIgetdir('Slectionner le dossier  importer :');
	if dirname == 0
		return
	end
	try
		IsaacImage(gcbf,IsaacIMG(dirname));
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
	parentdir = fileparts(dirname);
	IsaacCD(parentdir)
case 'MItemOpenImage'
	[filename,dirname] = IsaacUIgetfile('Ouvrir une image :');
	if filename == 0
		return
	end
	try
		IsaacImage(gcbf,fullfile(dirname,filename));
		IsaacCD(dirname)
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'MItemOpenSerie'
	dirname = IsaacUIgetdir('Slectionner le dossier de la srie :');
	if dirname == 0
		return
	end
	IsaacSerie(dirname)
	parentdir = fileparts(dirname);
	IsaacCD(parentdir)
case 'MItemSaveImage'
	% Contenu rel image cible
	try
		IsaacImage_save(ISAACPRIV.Cible,gcbf);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end			
case 'MItemSaveImageAs'
	% Contenu rel image cible
	name = IsaacImage_get(ISAACPRIV.Cible,'Name');
	[filename,dirname] = IsaacUIputfile('Sauver sous :',IsaacImgFileName(name));
	if filename == 0
		return
	end
	try
		IsaacImage_saveas(ISAACPRIV.Cible,gcbf,fullfile(dirname,filename));
		IsaacCD(dirname)
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'MItemRestaureImage'
	filename = IsaacImage_get(ISAACPRIV.Cible,'FileName');
	r = IsaacDialogQuestion(['Restaurer ',filename,' d''origine?'],0);
	if strcmp(r,'Oui')
		try
			IsaacImage(gcbf,ISAACPRIV.Cible);
		catch exception
			IsaacMessageErreur(IsaacError(exception))
		end
	end	
% Menu Outils ou Mes outils ------------------------------------------------------------------------
case 'MItemTool'
	LaunchTool(gcbo)
% Menu Modules ou Mes modules ----------------------------------------------------------------------
case 'MItemModule'
	LaunchModule(gcbo)
% Menu Images ouvertes -----------------------------------------------------------------------------
case 'MItemImage'
	ud = get(gcbf,'UserData');
	obj = ISAACPRIV.TabIsaacImage(get(gcbo,'Position'));
	if ud.PointeurInfo
		IsaacImage_finfo(obj);
	else
		% L'image devient la cible
		IsaacImage_cible(obj,gcbf);
	end	    
% Clic sur barre de menu Dveloppement -------------------------------------------------------------
case 'MajMenuDevelop'
	if ISAACPRIV.DispEvent
        val = 'on';
	else
        val = 'off';
	end    
	set(findobj(findobj(gcbf,'Tag','MenuDevelop'),'Tag','MItemDispEvent'),'Checked',val)
% Menu Dveloppement -------------------------------------------------------------------------------
case 'MItemDispEvent'
	ISAACPRIV.DispEvent = ~ISAACPRIV.DispEvent;
case 'MItemListMod'
	disp(' ')
	for i = 1:ISAACPRIV.NbMod
		disp(IsaacPathStr(fullfile(ISAACPRIV.TabMod(i).dirname,ISAACPRIV.TabMod(i).filename),4))
	end
case 'MItemReloadMod'
	try
		IsaacModuleReload;
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
	% menu Modules
	menuhnd = findobj(gcbf,'Tag','MenuModules');
	delete(findobj(allchild(menuhnd)))
	IsaacMenuBar_majmods(ISAACCONST.ModsDir,menuhnd,1,false);
	% menu Mes modules
	if ~isempty(ISAACPREF.UserModsDir)
		menuhnd = findobj(gcbf,'Tag','MenuMesModules');
		delete(findobj(allchild(menuhnd)))
		IsaacMenuBar_majmods(ISAACPREF.UserModsDir,menuhnd,1,false);
	end			
case 'MItemReloadTools'
	% menu Tools
	menuhnd = findobj(gcbf,'Tag','MenuOutils');
	delete(findobj(allchild(menuhnd)))
	% Items
	IsaacMenuBar_addtools(ISAACCONST.ToolsDir,menuhnd,1,false)
	% menu Mes outils
	if ~isempty(ISAACPREF.UserToolsDir)
		menuhnd = findobj(gcbf,'Tag','MenuMesOutils');
		delete(findobj(allchild(menuhnd)))
		% Items	
		IsaacMenuBar_addtools(ISAACPREF.UserToolsDir,menuhnd,1,false);
	end			
case 'MItemListFun'
	disp(' ')
	disp(inmem)
case 'MItemClearFun'
   % Dsactivation des warnings le temps du clear functions
   % sinon WARNING fonction en cours d'execution non efface depuis aprs MATLAB R2010b
   warning('off')
   clear functions                                                                              %#ok	
   warning('on')
case 'MItemListVar'
	disp(' ')
	disp('Current workspace :')
	whos
	disp('Base workspace :')
	evalin('base','whos')
case 'MItemClearVar'
	clear variables
	evalin('base','clear variables')
case 'MItemClearParamMem'
	ISAACPRIV.ParamMem = struct;
case 'MItemClearComWin'
	clc
% Menu Aide ----------------------------------------------------------------------------------------
case 'MItemDoc'
   web (['http://',ISAACCONST.Info.IsaacDoc1],'-browser')
case 'MItemAuteur'
	web (['mailto:',ISAACCONST.Info.AuthorEmail])
case 'MItemWeb1'
	web (['http://',ISAACCONST.Info.IsaacWeb1],'-browser')
case 'MItemWeb2'
	web (['http://',ISAACCONST.Info.IsaacWeb2],'-browser')   
end	

%---------------------------------------------------------------------------------------------------

function LaunchTool(hsrc) 
% Lancement de l'outil slectionn par l'item de menu de handle hsrc

toolname = get(hsrc,'Tag');
tooldir = get(hsrc,'UserData');
savedir = pwd;
try
	cd(tooldir)
	ud = get(gcbf,'UserData');
	if ud.PointeurInfo
		IsaacMessageInfo(true,['outil ',toolname],help(fullfile(tooldir,toolname)))
		% nom complet sinon tous les fichiers dont le nom contient toolname sont traits 
		% (depuis R14SP3)
	else
		feval(toolname);
	end
catch exception
	IsaacMessageErreur(IsaacError(exception))
end
cd(savedir)
%---------------------------------------------------------------------------------------------------

function LaunchModule(hsrc)
% Lancement du module slectionnpar l'item de menu de handle hsrc

modname = get(hsrc,'Tag');
moddir = get(hsrc,'UserData');
ud = get(gcbf,'UserData');
if ud.PointeurInfo
	savedir = pwd;
	try
		cd(moddir)
		IsaacMessageInfo(true,['module ',modname],help(fullfile(moddir,modname)))
		% nom complet sinon tous les fichiers qui contiennent modname sont traits 
		% (depuis R14SP3)
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
	cd(savedir)
else
	IsaacModBox(modname,moddir)
end
