function IsaacPrefs()
% Ecran Prferences (dialogue modal)
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%	DefaultDir		: nouvelle valeur de ISAACPREF.DefaultDir
%	UserToolsDir	: nouvelle valeur de ISAACPREF.UserToolsDir
%	UserModsDir		: nouvelle valeur de ISAACPREF.UserModsDir
%	ImMaxPlans		: nouvelle valeur de ISAACPREF.ImMaxPlans
%  Restart			: true | false si redmarrage d'Isaac ncessaire

%---------------------------------------------------------------------------------------------------

global ISAACPREF
global ISAACCONST

% cration cran prefs

hauteurfig = 350;
% figure(position selon ISAACCONST.DefPos)
h0 = figure( ...
	'CloseRequestFcn','IsaacPrefs_cb ButCancel', ...
	'Name','Prfrences', ...
	'Position',IsaacFenPos(ISAACCONST.DefPos(1),ISAACCONST.DefPos(2),445,hauteurfig,0), ...
	'WindowStyle','modal');

IsaacDefaultProperties(h0)

% cadre Gnral ------------------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'Position',[5 hauteurfig - 318 232 310], ...
	'Style','frame');
% text Gnral
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontAngle','italic', ...
	'Position',[12 hauteurfig - 17 50 15], ...
	'String','Gnral', ...
	'Style','text');
% text Mode
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[12 hauteurfig - 35 50 15], ...
	'String','Mode :', ...
	'Style','text');
% radiobouton Utilisateur
if (ISAACPREF.Mode == 1)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadUser', ...
	'Position',[12 hauteurfig - 55 75 15], ...
	'String','Utilisat. (*)', ...
	'Style','radiobutton', ...
	'Tag','RadUser', ...
	'Value',v);
% radiobouton Dvelop	
if (ISAACPREF.Mode == 2)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadDevelop', ...
	'Position',[93 hauteurfig - 55 70 15], ...
	'String','Dvelop.', ...
	'Style','radiobutton', ...
	'Tag','RadDevelop', ...
	'Value',v);
% radiobouton Dbug	
if (ISAACPREF.Mode == 3)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadDebug', ...
	'Position',[168 hauteurfig - 55 60 15], ...
	'String','Dbug', ...
	'Style','radiobutton', ...
	'Tag','RadDebug', ...
	'Value',v);
% text DefaultDir
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[12 hauteurfig - 85 150 15], ...
	'String','Dossier de dpart :', ...
	'Style','text');
% bouton DefaultDir
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButDefaultDir', ...
	'Position',[35 hauteurfig - 106 194 20], ...
	'String',IsaacPathStr(ISAACPREF.DefaultDir,2), ...
	'Style','pushbutton');
% text UserToolsDir
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[12 hauteurfig - 130 150 15], ...
	'String','Dossier mes outils (*) :', ...
	'Style','text');
if isempty(ISAACPREF.UserToolsDir)
	s1 = 'off';
	s2 = '';
	v = 0;
else
	s1 = 'on';
	s2 = IsaacPathStr(ISAACPREF.UserToolsDir,2);
	v = 1;
end
% checkbox UserToolsDir	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb ChkUserToolsDir', ...
	'Position',[10 hauteurfig - 150 18 18], ...
	'String','', ...
	'Style','checkbox', ...
	'Value',v);
% bouton UserToolsDir
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'CallBack','IsaacPrefs_cb ButUserToolsDir', ...
	'Enable',s1, ...
	'Position',[35 hauteurfig - 151 194 20], ...
	'String',s2, ...
	'Style','pushbutton', ...
	'Tag','ButUserToolsDir');
% text UserModsDir
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[12 hauteurfig - 175 150 15], ...
	'String','Dossier mes modules (*) :', ...
	'Style','text');
if isempty(ISAACPREF.UserModsDir)
	s1 = 'off';
	s2 = '';
	v = 0;
else
	s1 = 'on';
	s2 = IsaacPathStr(ISAACPREF.UserModsDir,2);
	v = 1;
end
% checkbox UserModsDir	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb ChkUserModsDir', ...
	'Position',[10 hauteurfig - 195 18 18], ...
	'String','', ...
	'Style','checkbox', ...
	'Value',v);
% bouton UserModsDir
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButUserModsDir', ...
	'Enable',s1, ...
	'Position',[35 hauteurfig - 196 194 20], ...
	'String',s2, ...
	'Style','pushbutton', ...
	'Tag','ButUserModsDir');
% text Optimisation des sries
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[10 hauteurfig - 245 150 15], ...
	'String','Optimisation des sries :', ...
	'Style','text');
% radiobouton Qualit
if (ISAACPREF.OptimiseSerMem == false)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadSerQual', ...
	'Position',[10 hauteurfig - 265 105 15], ...
	'String','Qualit (+ rapide)', ...
	'Style','radiobutton', ...
	'Tag','RadSerQual', ...
	'Value',v);
% radiobouton Mmoire	
if (ISAACPREF.OptimiseSerMem == false)
	v = 0;
else
	v = 1;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadSerMem', ...
	'Position',[125 hauteurfig - 265 105 15], ...
	'String','Mmoire (+ lent)', ...
	'Style','radiobutton', ...
	'Tag','RadSerMem', ...
	'Value',v);
% text Optimisation des images
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[10 hauteurfig - 288 150 15], ...
	'String','Optimisation des images :', ...
	'Style','text');
% radiobouton Rapidit
if (ISAACPREF.OptimiseImgMem == false)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadImgSpeed', ...
	'Position',[10 hauteurfig - 308 105 15], ...
	'String','Rapidit', ...
	'Style','radiobutton', ...
	'Tag','RadImgSpeed', ...
	'Value',v);
% radiobouton Mmoire	
if (ISAACPREF.OptimiseImgMem == false)
	v = 0;
else
	v = 1;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadImgMem', ...
	'Position',[125 hauteurfig - 308 105 15], ...
	'String','Mmoire (+ lent)', ...
	'Style','radiobutton', ...
	'Tag','RadImgMem', ...
	'Value',v);

% cadre Images -------------------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'Position',[242 hauteurfig - 160 200 152], ...
	'Style','frame');
% text Images	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontAngle','italic', ...
	'Position',[249 hauteurfig - 17 45 15], ...
	'String','Images', ...
	'Style','text');
% text format	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[249 hauteurfig - 35 150 15], ...
	'String','Sauver au format :', ...
	'Style','text');
% radiobouton ISA
if strcmp(ISAACPREF.ImForm,ISAACCONST.ExtImg)
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadISA', ...
	'Position',[249 hauteurfig - 55 50 15], ...
	'String','ISA', ...
	'Style','radiobutton', ...
	'Tag','RadISA', ...
	'Value',v);
% radiobouton TIF
if strcmp(ISAACPREF.ImForm,'.tif')
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadTIF', ...
	'Position',[300 hauteurfig - 55 50 15], ...
	'String','TIF', ...
	'Style','radiobutton', ...
	'Tag','RadTIF', ...
	'Value',v);
% radiobouton BMP
if strcmp(ISAACPREF.ImForm,'.bmp')
	v = 1;
else
	v = 0;
end	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb RadBMP', ...
	'Position',[350 hauteurfig - 55 50 15], ...
	'String','BMP', ...
	'Style','radiobutton', ...
	'Tag','RadBMP', ...
	'Value',v);
% text MaxPlans
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[249 hauteurfig - 85 150 15], ...
	'String','Nombre maximum de plans (*) :', ...
	'Style','text');
% edit MaxPlans	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor2, ...
	'Callback','IsaacPrefs_cb EtxtMaxPlans', ...
	'FontSize',ISAACPREF.FontSize, ...
	'Position',[405 hauteurfig - 89 30 22], ...
	'String',num2str(ISAACPREF.ImMaxPlans), ...
	'Style','edit');
% text Options
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[249 hauteurfig - 110 70 15], ...
	'String','Options :', ...
	'Style','text');
% checkbox ImFullName	
uicontrol('Parent',h0, ...
	'Position',[249 hauteurfig - 130 140 18], ...
	'String','Noms d''images longs', ...
	'Style','checkbox', ...
	'Tag','ChkImFullName', ...
	'Value',ISAACPREF.ImFullName);
% checkbox ShowImType	
uicontrol('Parent',h0, ...
	'Position',[249 hauteurfig - 150 140 18], ...
	'String','Afficher type', ...
	'Style','checkbox', ...
	'Tag','ChkShowImType', ...
	'Value',ISAACPREF.ShowImType);
% cadre Interface  ------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'Position',[242 hauteurfig - 318 200 149], ...
	'Style','frame');
% text Interface	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontAngle','italic', ...
	'Position',[249 hauteurfig - 176 50 15], ...
	'String','Interface', ...
	'Style','text');
% checkbox Son	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb ChkSon', ...
	'Position',[250 hauteurfig - 195 51 18], ...
	'String','Son', ...
	'Style','checkbox', ...
	'Tag','ChkSon', ...
	'Value',ISAACPREF.Son);
% checkbox CloseMenuEnd	
uicontrol('Parent',h0, ...
	'Callback','IsaacPrefs_cb ChkSCloseMenuEnd', ...
	'Position',[305 hauteurfig - 195 135 18], ...
	'String','Fermer menu = Quitter', ...
	'Style','checkbox', ...
	'Tag','ChkSCloseMenuEnd', ...
	'Value',ISAACPREF.CloseMenuEnd);
% text Police
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[250 hauteurfig - 220 45 15], ...
	'String','Police :', ...
	'Style','text');
% bouton Police
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButPolice', ...
	'FontName',ISAACPREF.FontName, ...
	'FontSize',ISAACPREF.FontSize, ...
	'Position',[296 hauteurfig - 221 135 20], ...
	'String',[ISAACPREF.FontName,' ',num2str(ISAACPREF.FontSize)], ...
	'Style','pushbutton', ...
	'Tag','ButPolice');
% text IsaacColor	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[250 hauteurfig - 248 50 15], ...
	'String','Fentres', ...
	'Style','text');
% bouton IsaacColor1
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor1, ...
	'Callback','IsaacPrefs_cb ButIsaacColor1', ...
	'Position',[310 hauteurfig - 250 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButIsaacColor1');
% bouton IsaacColor2
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor2, ...
	'Callback','IsaacPrefs_cb ButIsaacColor2', ...
	'Position',[335 hauteurfig - 250 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButIsaacColor2');
% bouton IsaacColor3
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButIsaacColor3', ...
	'Position',[360 hauteurfig - 250 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButIsaacColor3');
% text TextColor	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[250 hauteurfig - 268 50 15], ...
	'String','Texte', ...
	'Style','text');
% bouton TextColor1
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.TextColor1, ...
	'Callback','IsaacPrefs_cb ButTextColor1', ...
	'Position',[310 hauteurfig - 270 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButTextColor1');
% bouton TextColor2
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.TextColor2, ...
	'Callback','IsaacPrefs_cb ButTextColor2', ...
	'Position',[335 hauteurfig - 270 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButTextColor2');
% bouton TextColor3
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.TextColor3, ...
	'Callback','IsaacPrefs_cb ButTextColor3', ...
	'Position',[360 hauteurfig - 270 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButTextColor3');
% text CibleColor	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[250 hauteurfig - 288 50 15], ...
	'String','Cible', ...
	'Style','text');
% bouton CibleColor1
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.CibleColor1, ...
	'Callback','IsaacPrefs_cb ButCibleColor1', ...
	'Position',[310 hauteurfig - 290 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButCibleColor1');
% bouton CibleColor2
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.CibleColor2, ...
	'Callback','IsaacPrefs_cb ButCibleColor2', ...
	'Position',[335 hauteurfig - 290 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButCibleColor2');
% text RoiColor	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[250 hauteurfig - 308 50 15], ...
	'String','ROI', ...
	'Style','text');
% bouton ROIColor1
uicontrol('Parent',h0, ...
	'BackgroundColor',im2double(ISAACPREF.ROIColor1), ...
	'Callback','IsaacPrefs_cb ButROIColor1', ...
	'Position',[310 hauteurfig - 310 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButROIColor1');
% bouton ROIColor2
uicontrol('Parent',h0, ...
	'BackgroundColor',im2double(ISAACPREF.ROIColor2), ...
	'Callback','IsaacPrefs_cb ButROIColor2', ...
	'Position',[335 hauteurfig - 310 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButROIColor2');
% bouton ROIColor3
uicontrol('Parent',h0, ...
	'BackgroundColor',im2double(ISAACPREF.ROIColor3), ...
	'Callback','IsaacPrefs_cb ButROIColor3', ...
	'Position',[360 hauteurfig - 310 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButROIColor3');
% bouton ROIColor4
uicontrol('Parent',h0, ...
	'BackgroundColor',im2double(ISAACPREF.ROIColor4), ...
	'Callback','IsaacPrefs_cb ButROIColor4', ...
	'Position',[385 hauteurfig - 310 16 16], ...
	'String',' ', ...
	'Style','pushbutton', ...
	'Tag','ButROIColor4');
% text infoprefs
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACPREF.TextColor3, ...
	'HorizontalAlignment','left', ...	
	'Position',[10 hauteurfig - 350 430 25], ...
	'String','(*) ATTENTION redmarrage immdiat', ...
	'Style','text');
% Bouton Reset
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButReset', ...
	'Position',[250 hauteurfig - 343 60 20], ...
	'String','Reset (*)');
% Bouton Cancel
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButCancel', ...
	'Position',[315 hauteurfig - 343 60 20], ...
	'String','Annuler');
% Bouton OK	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacPrefs_cb ButOk', ...
	'Position',[380 hauteurfig - 343 60 20], ...
	'String','Valider');

%---------------------------------------------------------------------------------------------------

% Initialisation
ud.DefaultDir = ISAACPREF.DefaultDir;
ud.UserToolsDir = ISAACPREF.UserToolsDir;
ud.UserModsDir = ISAACPREF.UserModsDir;
ud.ImMaxPlans = ISAACPREF.ImMaxPlans;
ud.Restart = false;
set(h0,'UserData',ud)
uiwait(h0) % bloque l'execution de l'appelant jusqu' resume ou close figure
