function IsaacSerie(dirname)
% Visualisation srie d'images
% Double-clic sur 1 imagette ouvre l'image qui devient la cible
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% dirname : champ UserData

%---------------------------------------------------------------------------------------------------

global ISAACPREF
global ISAACCONST

sername = IsaacPathStr(dirname,0);

% figure(position selon ISAACCONST.DefPos)
h0 = figure( ...
	'CloseRequestFcn','IsaacSerie_cb CloseBox', ...
	'Name',sername, ...
	'Position',IsaacFenPos(ISAACCONST.DefPos(1),ISAACCONST.DefPos(2),300,300,0), ...
	'ResizeFcn','IsaacSerie_cb Resize');

IsaacDefaultProperties(h0)
% modif des proprits pour permettre le resize et resize automatique des axes :
set(h0,'DefaultAxesUnits','normalized','Resize','on') 

% Bouton Copie cran
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacSerie_cb ButScreenCopy', ...
	'Position',[207 15 80 20], ...
	'String','Copie cran', ...
	'Tag','ButScreenCopy');
% Bouton Copie cran
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACPREF.IsaacColor3, ...
	'Callback','IsaacSerie_cb ButScreenCopy', ...
	'Position',[207 15 80 20], ...
	'String','Image srie', ...
	'Tag','ButScreenCopy');
% Axes et images
dd = IsaacDir(dirname,'f',true,false);
j = length(dd);
nb = 0;
if (j)
	% nb de vignettes = dimx x dimy tq dimx = dimy ou dimy+1
	dimx = ceil(sqrt(j)); % nb de vignettes en horizontal
	dimy = ceil(j/dimx);  % nb de vignettes en vertical
	for i = 1:j
		try
			objIMG = IsaacIMG(dd{i});
			img = IsaacIMG_get(objIMG,'Img');
			nb = nb+1;
			a = subplot(dimy,dimx,nb);
			NbPlans = IsaacIMG_get(objIMG,'DimZ');
			if (NbPlans ~= 1) && (NbPlans ~= 3)
				img = img(:,:,1);
			end	
			if ISAACPREF.OptimiseSerMem
				% coeffreduc = 64 / max(dimensions image) 
            h2 = imshow(imresize(img,64/max(size(img)),'nearest'));
			else
            h2 = imshow(img);
			end
			[~,imgname,ext] = fileparts(dd{i});
			imgname = [imgname,ext];																					%#ok
			set(h2,'ButtonDownFcn','IsaacSerie_cb ImClick','UserData', imgname)
			set(a,'FontSize',ISAACPREF.FontSize - 1,'XTick',[],'YTick',[])
			title(imgname)
		catch
			IsaacMessageBavard(dd{i},'n''est pas une image valide')
		end
	end
end
if nb >0
	set(h0,'UserData',dirname)
	if nb ~= j
		k = j-nb;
		if (k == 1)
			s = ' fichier n''est pas une image valide';
		else
			s = ' fichiers ne sont pas des images valides';
		end	
		IsaacMessageWarning(['srie ',sername],[num2str(k),s])
	end	
else
	IsaacMessageErreur(['le dossier ',dirname],'ne contient aucune image valide')
	delete(h0)
end
