function IsaacSerie_cb(choix)
% Callback IsaacSerie
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST

switch(choix)
case 'ImClick'
	ClickType = get(gcbf,'SelectionType');
	if strcmp(ClickType,'open')
		try
			dirname = get(gcbf,'UserData');
			imgname = get(gcbo,'UserData');
			IsaacImage(gcbf,fullfile(dirname,imgname));
		catch exception
			IsaacMessageErreur(IsaacError(exception))
		end
	end	
case 'Resize'
	pos = get(gcbf,'Position');
	set(findobj(gcbf,'Tag','ButScreenCopy'),'Position',[pos(3)-80-13,15,80,22])
case 'ButScreenCopy'
	try
		dirname = get(gcbf,'UserData');
		[~,dname] = fileparts(dirname);
		filename = IsaacFileName([dname,'.tif']);
		figure(gcbf)
		IsaacSound('Photo')
		print('-dtiffnocompression','-noui',fullfile(ISAACCONST.TempDir,filename))
		IsaacImage(gcbf,fullfile(ISAACCONST.TempDir,filename));
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'CloseBox'
	closereq
end
